## mingw-w64-precice-3.2.0-6.src.tar.zst

=== tools/profiling/CMakeLists.txt ===
# Adds the tests for the precice-profiling

# Single directory tests

set(_tests
  from-common-dir
  one-parallel-solver
  one-parallel-solver-missing-ranks
  one-parallel-solver-different-ids
  one-serial-damaged
  one-serial-solver
  one-solver-multiple-runs
  two-mixed-solvers
  two-parallel-solvers
  two-serial-solvers
  )

set(_precice_profiling "${CMAKE_CURRENT_LIST_DIR}/precice-profiling")
set(_test_script "${CMAKE_CURRENT_LIST_DIR}/tests/simple-test.cmake")
set(_test_root "${PROJECT_BINARY_DIR}/TestOutput")

# Check if polars is installed
set(_test_message_suffix "")
execute_process(COMMAND ${Python3_EXECUTABLE} -c "import polars"
  RESULTS_VARIABLE PRECICE_PYTHON_POLARS_CHECK
  OUTPUT_QUIET ERROR_QUIET)
if(NOT "${PRECICE_PYTHON_POLARS_CHECK}" EQUAL "0")
  message(STATUS "The python package polars is not installed. Profiling tests will be limited. Install polars using your package manager or \"pip install polars\" to enable all profiling tests.")
  set(_test_message_suffix " - limited")
endif()

foreach(test IN LISTS _tests)
  set(_test_name precice.tools.profiling.${test})
  set(_test_location "${CMAKE_CURRENT_LIST_DIR}/tests/${test}")
  set(_test_wd "${_test_root}/tools.profiling.${test}")
  file(MAKE_DIRECTORY ${_test_wd})
  message(STATUS "Test ${_test_name}${_test_message_suffix}")
  add_test(NAME ${_test_name}
    COMMAND ${CMAKE_COMMAND} -DPROFILING_SCRIPT=${_precice_profiling} -DTEST_FOLDER=${_test_location} -DFOLDER_ARG=${_test_location} -P ${_test_script}
    WORKING_DIRECTORY ${_test_wd}
    )
endforeach(test)

# Multi directory tests

set(test from-solver-dirs)
set(_test_name precice.tools.profiling.${test})
set(_test_location "${CMAKE_CURRENT_LIST_DIR}/tests/${test}")
set(_test_wd "${PROJECT_BINARY_DIR}/TestOutput/tools.profiling.${test}")
file(MAKE_DIRECTORY ${_test_wd})
message(STATUS "Test ${_test_name}${_test_message_suffix}")
add_test(NAME ${_test_name}
  COMMAND ${CMAKE_COMMAND} -DPROFILING_SCRIPT=${_precice_profiling} -DTEST_FOLDER=${_test_location} -DFOLDER_ARG=${_test_location}/A\;${_test_location}/B -P ${_test_script}
  WORKING_DIRECTORY ${_test_wd}
  )

unset(_precice_profiling)
unset(_test_location)
unset(_test_message_suffix)
unset(_test_name)
unset(_test_root)
unset(_test_script)
unset(_test_wd)

=== extras/bindings/c/CMakeLists.txt ===
set_property(TARGET precice PROPERTY PUBLIC_HEADER
  ${CMAKE_CURRENT_LIST_DIR}/include/precice/preciceC.h
  APPEND)

target_sources(preciceCore PRIVATE
  ${CMAKE_CURRENT_LIST_DIR}/include/precice/preciceC.h
  ${CMAKE_CURRENT_LIST_DIR}/src/preciceC.cpp
  )

target_include_directories(preciceCore PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>
  )

target_include_directories(precice PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>
  )

=== tools/testing/communication_dummies/SConstruct ===
import os;
import sys;

preciceLibPath = '../../build/last'
preciceLib = 'precice'
preciceIncPath = '../../src'

def errorMissingLib(lib, usage):
    print "ERROR: Library '" + lib + "' (needed for " + usage + ") not found!"
    Exit(1)

def errorMissingHeader(header, usage):
    print "ERROR: Header '" + header + "' (needed for " + usage + ") not found or does not compile!"
    Exit(1)

env = Environment (
   CXX = 'mpicxx',
   CCFLAGS    = ['-O3', '-std=c++11'],
   ENV        = os.environ
   )

conf = Configure(env)

conf.env.AppendUnique(LIBPATH = [preciceLibPath])

if conf.CheckLib(preciceLib, autoadd=0):
    conf.env.AppendUnique(LIBS = [preciceLib])
else:
    errorMissingLib(preciceLib, 'preCICE')

conf.env.AppendUnique(CPPPATH = [preciceIncPath])

conf.env.Program (
    target = 'A',
    source = [
      Glob('mainA.cpp')
    ]
    )

conf.env.Program (
    target = 'B',
    source = [
      Glob('mainB.cpp'),
    ]
    )

=== PKGBUILD ===
# Maintainer: Rafal Brzegowy <rafal.brzegowy@yahoo.com>
# Contributor: Raed Rizqie <raed.rizqie@gmail.com>

_realname=precice
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.2.0
pkgrel=6
pkgdesc='A Coupling Library for Partitioned Multi-Physics Simulations on Massively Parallel Systems (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.precice.org'
msys2_repository_url='https://github.com/precice/precice'
license=('spdx:LGPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         #"${MINGW_PACKAGE_PREFIX}-petsc"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             $([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi")
             #"${MINGW_PACKAGE_PREFIX}-ninja"
             #"${MINGW_PACKAGE_PREFIX}-petsc-build"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "git")
source=(https://github.com/precice/precice/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        001-fix-libprecice-dll-installation.patch
        002-fix-export-defs.patch::https://github.com/precice/precice/commit/f7a4723827bbf20062fe004322b837f348374af3.patch
        003-add-win32-deps.patch::https://github.com/precice/precice/commit/2d08cf23abe81490f11c2be0e00afd43648ee504.patch
        004-fix-build-with-libxml2-2.14.patch::https://github.com/precice/precice/commit/d54c0e6d9e62ce314a91f05f51635472f0758b07.patch
        005-fix-find-eigen3-5.patch::https://github.com/precice/precice/commit/50486d75.patch
        006-fix-build-with-boost-1.89.patch::https://github.com/precice/precice/commit/625092d2.patch)
sha256sums=('93523f1a56e0cfd338d8e190baa06129ee811acdb1c697468a3c85c516d63464'
            '49fe04f9e72d1034b8909a7b593ccf42eeaf5203d9188f71706260948a0fb566'
            '8efe809bf94f93d2fa0bcdf6cc95cda4028a469b5bd88c5a1a7b0738e615e05a'
            '786d2f0be4e6131192501bf81d574ca5b3839e6de95a78de3ceea0738c7fa81a'
            '37215fbc9a43a2628edfba4db4c52554766f1ab5bbfc1f7324050a3ebe26a9ae'
            '67ab7649a5301a1d2b2e10de6caeb1a1c5dce65c5ca6bbc8267fe4399094804e'
            'b31a11ce89d4f72ac9c840d0658f5a0de3eaf93124b4a1a8733d109ac39fba20')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    001-fix-libprecice-dll-installation.patch \
    002-fix-export-defs.patch \
    003-add-win32-deps.patch \
    004-fix-build-with-libxml2-2.14.patch \
    005-fix-find-eigen3-5.patch \
    006-fix-build-with-boost-1.89.patch
}

build() {
  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  # . ${MINGW_PREFIX}/src/petsc/petsc
  # for build in ${petsc_builds}; do
  #   #export PETSC_ARCH=${build}
  #   export PETSC_ARCH=dmo
  #   export PETSC_DIR=${MINGW_PREFIX}/src/petsc
  # done

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == aarch64 ]]; then
    extra_config+=("-DPRECICE_FEATURE_MPI_COMMUNICATION=OFF")
  else
    extra_config+=("-DPRECICE_FEATURE_MPI_COMMUNICATION=ON")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    CXXFLAGS+=" -Wno-c++11-narrowing"
  else
    CXXFLAGS+=" -Wno-narrowing"
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -G"Ninja" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_TESTING=OFF \
      ${extra_config[@]} \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -DPRECICE_FEATURE_PETSC_MAPPING=OFF \
      -DPRECICE_FEATURE_PYTHON_ACTIONS=ON \
      -DPRECICE_BUILD_TOOLS=ON \
      -Wno-dev \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
